/******************************************************************************/
/* SISTEMAS INTEGRADOS TECNISA                                                */
/* NOME: 0052_STPSDXO_USR_IMPORTA_AF.SQL                                      */
/*                                                                            */
/* DESCRIO:                                                                 */
/* REALIZA A IMPORTAO DAS AF'S GERADAS PELO SISTEMA SAC PARA O TECFOOD      */
/* CRIAO:                                                                   */
/* 12/06/2008 - RAQUEL CUNHA                                                  */
/******************************************************************************/

CREATE OR REPLACE
PROCEDURE USR_IMPORTA_AF
  (P_CDFILLANC IN VARCHAR2,
   P_CDFILIAL  IN VARCHAR2 DEFAULT NULL,
   P_ATUALIZAR IN VARCHAR2 DEFAULT 'N') IS

   V_CDPRODUTO VARCHAR(10);
   V_CDFILIAL VARCHAR(4);
   V_CDEMPRESA VARCHAR(2);
   V_CDFORNECED VARCHAR(21);
   V_IDTPIJURFORN VARCHAR(1);
   V_NRINSJURFORN VARCHAR(20);
   V_EXIST_PROD VARCHAR(10);
   V_NRAUTOFORN VARCHAR(10);
   V_IDTIPEMITGER VARCHAR(1);
   V_CODIGO VARCHAR2(20);
   V_LISTA  VARCHAR2(20);

   V_AF_SOLFIL_IDSOL NUMBER;
   V_AF_PEDIDO_CDPED NUMBER;
   V_AF_CPOPRO_CDPRO VARCHAR(20);
   V_AF_SOLITE_DTENT DATE;
   V_AF_SOLFIL_DTREF DATE;
   V_AF_CADFIL_CDFIL VARCHAR(4);
   V_AF_CADFOR_NRCGC VARCHAR(15);
   V_AF_SOLITE_VLPCO NUMBER;
   V_AF_SOLITE_QTSOL NUMBER;
   V_AF_SOLITE_QTCPA NUMBER;
   V_AF_CDIMPORTAF   VARCHAR(1);

   V_ANT_CDFORNECED  VARCHAR2(21);
   V_ANT_CDFILDEST   VARCHAR2(4);
   V_ANT_CDPED       NUMBER;

   V_BAIXA_AF        VARCHAR2(1);
   V_NRAUTOFORN_OLD  VARCHAR2(10);

   CURSOR C_AF IS
      SELECT
         SAC.SOLFIL_IDSOL, SAC.PEDIDO_CDPED, SAC.CPOPRO_CDPRO,
         SAC.SOLITE_DTENT, SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC),
         TO_DATE(SAC.SOLFIL_DTREF||'01', 'YYYYMMDD'), SAC.SOLITE_VLPCO, SAC.SOLITE_QTSOL,
         SAC.SOLITE_QTCPA, SAC2.CDIMPORTAF
      FROM
         CMPPROD.VW_SACA2B_AF@SDXLOGIS SAC,
         CMPPROD.ITEMAF_SACA2B@SDXLOGIS SAC2
      WHERE
         SAC.SOLFIL_IDSOL = SAC2.SOLFIL_IDSOL(+) AND
         SAC.PEDIDO_CDPED = SAC2.PEDIDO_CDPED(+) AND
         SAC.CPOPRO_CDPRO = SAC2.CPOPRO_CDPRO(+) AND
         SAC.SOLITE_DTENT = SAC2.SOLITE_DTENT(+) AND
         NVL(SAC2.CDIMPORTAF, 'S') = 'S'
      ORDER BY
         SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC), SAC.PEDIDO_CDPED;

   CURSOR C_AFFILI IS
      SELECT
         SAC.SOLFIL_IDSOL, SAC.PEDIDO_CDPED, SAC.CPOPRO_CDPRO,
         SAC.SOLITE_DTENT, SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC),
         TO_DATE(SAC.SOLFIL_DTREF||'01', 'YYYYMMDD'), SAC.SOLITE_VLPCO, SAC.SOLITE_QTSOL,
         SAC.SOLITE_QTCPA, SAC2.CDIMPORTAF
      FROM
         CMPPROD.VW_SACA2B_AF@SDXLOGIS SAC,
         CMPPROD.ITEMAF_SACA2B@SDXLOGIS SAC2
      WHERE
         SAC.SOLFIL_IDSOL = SAC2.SOLFIL_IDSOL(+) AND
         SAC.PEDIDO_CDPED = SAC2.PEDIDO_CDPED(+) AND
         SAC.CPOPRO_CDPRO = SAC2.CPOPRO_CDPRO(+) AND
         SAC.SOLITE_DTENT = SAC2.SOLITE_DTENT(+) AND
         NVL(SAC2.CDIMPORTAF, 'S') = 'S'         AND
         SAC.CADFIL_CDFIL = P_CDFILIAL
      ORDER BY
         SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC), SAC.PEDIDO_CDPED;
BEGIN
   V_ANT_CDFORNECED := NULL;
   V_ANT_CDFILDEST  := NULL;
   V_ANT_CDPED      := NULL;
   V_LISTA          := NULL;
   IF P_CDFILIAL IS NULL THEN
      OPEN C_AF;
   ELSE
      OPEN C_AFFILI;
   END IF;
   LOOP
      IF P_CDFILIAL IS NULL THEN
         FETCH C_AF INTO V_AF_SOLFIL_IDSOL,
                         V_AF_PEDIDO_CDPED,
                         V_AF_CPOPRO_CDPRO,
                         V_AF_SOLITE_DTENT,
                         V_AF_CADFIL_CDFIL,
                         V_AF_CADFOR_NRCGC,
                         V_AF_SOLFIL_DTREF,
                         V_AF_SOLITE_VLPCO,
                         V_AF_SOLITE_QTSOL,
                         V_AF_SOLITE_QTCPA,
                         V_AF_CDIMPORTAF;
         EXIT WHEN C_AF%NOTFOUND;
      ELSE
         FETCH C_AFFILI INTO V_AF_SOLFIL_IDSOL,
                             V_AF_PEDIDO_CDPED,
                             V_AF_CPOPRO_CDPRO,
                             V_AF_SOLITE_DTENT,
                             V_AF_CADFIL_CDFIL,
                             V_AF_CADFOR_NRCGC,
                             V_AF_SOLFIL_DTREF,
                             V_AF_SOLITE_VLPCO,
                             V_AF_SOLITE_QTSOL,
                             V_AF_SOLITE_QTCPA,
                             V_AF_CDIMPORTAF;
         EXIT WHEN C_AFFILI%NOTFOUND;
      END IF;
      SELECT
         MAX(CDPRODUTO)
      INTO
         V_CDPRODUTO
      FROM
         PRODINTDOS
      WHERE
          IDPRODINTDOS = 'G'
      AND CDPRODINTDOS = V_AF_CPOPRO_CDPRO;

      IF V_CDPRODUTO IS NOT NULL THEN
         SELECT
            MAX(CDFILIAL)
         INTO
            V_CDFILIAL
         FROM FILIAL
         WHERE
            CDFILIAL = V_AF_CADFIL_CDFIL;
         IF V_CDFILIAL IS NOT NULL THEN
            SELECT
               DECODE(MAX(PARCMPSUP.IDTIPEMITGER), 1, MAX(FILIAL.CDEMPRESA), MAX(PARCMPSUP.CDEMPRESA)) CDEMPRESA,
               MAX(PARCMPSUP.IDTIPEMITGER)
            INTO
               V_CDEMPRESA,
               V_IDTIPEMITGER
            FROM
               PARCMPSUP, FILIAL
            WHERE
               FILIAL.CDFILIAL    = PARCMPSUP.CDFILIAL AND
               PARCMPSUP.CDFILIAL = V_AF_CADFIL_CDFIL;
            IF V_CDEMPRESA IS NOT NULL THEN
               SELECT
                  MAX(CDFORNECED),
                  MAX(IDTPIJURFORN),
                  MAX(NRINSJURFORN)
               INTO
                  V_CDFORNECED,
                  V_IDTPIJURFORN,
                  V_NRINSJURFORN
               FROM
                  FORNECEDOR
               WHERE
                  NRINSJURFORN LIKE '%'||V_AF_CADFOR_NRCGC;
               IF V_CDFORNECED IS NOT NULL THEN
                  SELECT
                     MAX(CDPRODUTO)
                  INTO
                     V_EXIST_PROD
                  FROM
                     PRODUTO
                  WHERE
                     CDPRODUTO = V_CDPRODUTO;
                  IF V_EXIST_PROD IS NOT NULL THEN
                     SELECT
                        MAX(AUTOFORNE.NRAUTOFORN)
                     INTO
                        V_NRAUTOFORN
                     FROM
                        ITEMAUTF,
                        AUTOFORNE
                     WHERE
                        AUTOFORNE.CDFILDEST  = V_AF_CADFIL_CDFIL     AND
                        AUTOFORNE.CDFILLANC  = V_AF_CADFIL_CDFIL     AND
                        AUTOFORNE.CDFORNECED = V_CDFORNECED          AND
                        AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST    AND
                        AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC    AND
                        AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN   AND
                        ITEMAUTF.CDMARCA     = '99999'               AND
                        ITEMAUTF.CDPRODUTO   = V_CDPRODUTO           AND
                        TO_DATE(ITEMAUTF.DTPROGENTAF, 'DD/MM/YYYY') = TO_DATE(V_AF_SOLITE_DTENT, 'DD/MM/YYYY')     AND
                        ITEMAUTF.SDX_CDPEDCOMPRA = V_AF_PEDIDO_CDPED;
                     IF V_NRAUTOFORN IS NULL THEN
                        IF (NVL(V_ANT_CDFORNECED, ' ') <> V_CDFORNECED)      OR
                           (NVL(V_ANT_CDFILDEST,  ' ') <> V_AF_CADFIL_CDFIL) OR
                           (NVL(V_ANT_CDPED, 0.1)      <> V_AF_PEDIDO_CDPED) THEN
                           V_ANT_CDFORNECED := V_CDFORNECED;
                           V_ANT_CDFILDEST  := V_AF_CADFIL_CDFIL;
                           V_ANT_CDPED      := V_AF_PEDIDO_CDPED;
                           NOVO_CODIGO('AUTOFORNE', V_CODIGO, 1);
                           V_CODIGO := SUBSTR(V_CODIGO, 11, 10);
                           IF V_LISTA IS NULL THEN
                              NOVO_CODIGO('LISTA', V_LISTA, 1);
                              V_LISTA := SUBSTR(V_LISTA, 11, 10);
                           END IF;

                           INSERT INTO LISTA (NRLISTA, CDLISTA)
                           VALUES(V_LISTA, V_AF_CADFIL_CDFIL||V_AF_CADFIL_CDFIL||V_CODIGO);

                           INSERT INTO AUTOFORNE
                              (CDFILDEST, CDFILLANC, NRAUTOFORN, CDOPERADOR,
                               IDTIPOEMITAF, CDEMPRESA, CDFORNECED, DTAUTOFORN)
                           VALUES
                              (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_CODIGO,
                               '000000000999', V_IDTIPEMITGER, V_CDEMPRESA,
                               V_CDFORNECED, V_AF_SOLFIL_DTREF);
                           IF V_AF_PEDIDO_CDPED IS NOT NULL THEN
                              INSERT INTO MENSAUTF
                                 (CDFILDEST, CDFILLANC, NRAUTOFORN,
                                  NRMENSAUTFOR,DSMENSAF)
                              VALUES
                                 (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_CODIGO,
                                  '00', V_AF_PEDIDO_CDPED);
                           END IF;
                           INSERT INTO MENSAUTF
                              (CDFILDEST, CDFILLANC, NRAUTOFORN,
                               NRMENSAUTFOR,DSMENSAF)
                           VALUES
                              (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_CODIGO,
                               '01', 'COMPRA CENTRALIZADA');
                        END IF;
                        INSERT INTO ITEMAUTF
                           (CDFILDEST, CDFILLANC, NRAUTOFORN,
                            CDPRODUTO, CDMARCA, DTPROGENTAF, SDX_CDPEDCOMPRA,
                            VRPREUNIAF, QTPROGENTAF, NRPARCITMAF, IDTPLANITEAF)
                        SELECT V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_CODIGO,
                            V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, V_AF_PEDIDO_CDPED,
                            V_AF_SOLITE_VLPCO, V_AF_SOLITE_QTSOL, '00', 'A'
                          FROM DUAL
                         WHERE NOT EXISTS (SELECT 1
                                             FROM ITEMAUTF I
                                            WHERE I.CDFILDEST        = V_AF_CADFIL_CDFIL
                                              AND I.CDFILLANC        = V_AF_CADFIL_CDFIL
                                              AND I.CDMARCA          = '99999'
                                              AND I.CDPRODUTO        = V_CDPRODUTO
                                              AND TO_DATE(I.DTPROGENTAF, 'DD/MM/YYYY') = TO_DATE(V_AF_SOLITE_DTENT, 'DD/MM/YYYY')
                                              AND I.SDX_CDPEDCOMPRA  = V_AF_PEDIDO_CDPED);
                        IF SQL%ROWCOUNT = 0 THEN
                           SELECT NRAUTOFORN
                             INTO V_NRAUTOFORN_OLD
                             FROM ITEMAUTF I
                            WHERE I.CDFILDEST        = V_AF_CADFIL_CDFIL
                              AND I.CDFILLANC        = V_AF_CADFIL_CDFIL
                              AND I.CDMARCA          = '99999'
                              AND I.CDPRODUTO        = V_CDPRODUTO
                              AND TO_DATE(I.DTPROGENTAF, 'DD/MM/YYYY') = TO_DATE(V_AF_SOLITE_DTENT, 'DD/MM/YYYY')
                              AND I.SDX_CDPEDCOMPRA  = V_AF_PEDIDO_CDPED;

                           UPDATE ITEMAUTF
                              SET VRPREUNIAF  = V_AF_SOLITE_VLPCO,
                                  QTPROGENTAF = V_AF_SOLITE_QTSOL
                            WHERE CDFILDEST   = V_AF_CADFIL_CDFIL AND
                                  CDFILLANC   = V_AF_CADFIL_CDFIL AND
                                  NRAUTOFORN  = V_NRAUTOFORN_OLD AND
                                  CDPRODUTO   = V_CDPRODUTO AND
                                  CDMARCA     = '99999' AND
                                  TO_DATE(DTPROGENTAF, 'DD/MM/YYYY') = TO_DATE(V_AF_SOLITE_DTENT, 'DD/MM/YYYY');
                        END IF;
                        INSERT INTO MOVOPAF
                           (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                            CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                        VALUES
                           (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_CODIGO,
                            V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                            'PRODUTO IMPORTADO - Nmero Pedido SAC:'||V_AF_PEDIDO_CDPED||'(Incluso)', '');

                        UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           SET CDIMPORTAF = 'P',
                               DTIMPORTAF = SYSDATE
                           WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                                 PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                                 CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                                 SOLITE_DTENT = V_AF_SOLITE_DTENT;
                        IF SQL%ROWCOUNT = 0 THEN
                           INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                              (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                               CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                           VALUES
                              (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                               V_AF_SOLITE_DTENT, 'P', '', SYSDATE, '', '');
                        END IF;
                        COMMIT;
                     ELSE
                        IF P_ATUALIZAR = 'S' THEN
                           IF V_LISTA IS NULL THEN
                              NOVO_CODIGO('LISTA', V_LISTA, 1);
                              V_LISTA := SUBSTR(V_LISTA, 11, 10);
                           END IF;

                           INSERT INTO LISTA (NRLISTA, CDLISTA)
                           SELECT V_LISTA, V_AF_CADFIL_CDFIL||V_AF_CADFIL_CDFIL||V_NRAUTOFORN
                           FROM DUAL
                           WHERE NOT EXISTS (SELECT 1
                                             FROM LISTA L
                                             WHERE L.NRLISTA = V_LISTA
                                               AND L.CDLISTA = V_AF_CADFIL_CDFIL||V_AF_CADFIL_CDFIL||V_NRAUTOFORN);

                           UPDATE ITEMAUTF
                           SET VRPREUNIAF  = V_AF_SOLITE_VLPCO,
                               QTPROGENTAF = V_AF_SOLITE_QTSOL
                           WHERE CDFILDEST   = V_AF_CADFIL_CDFIL AND
                                 CDFILLANC   = V_AF_CADFIL_CDFIL AND
                                 NRAUTOFORN  = V_NRAUTOFORN AND
                                 CDPRODUTO   = V_CDPRODUTO AND
                                 CDMARCA     = '99999' AND
                                 TO_DATE(DTPROGENTAF, 'DD/MM/YYYY') = TO_DATE(V_AF_SOLITE_DTENT, 'DD/MM/YYYY');

                           INSERT INTO MOVOPAF
                              (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                               CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                           VALUES
                              (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_NRAUTOFORN,
                               V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                               'PRODUTO IMPORTADO - Nmero Pedido SAC:'||V_AF_PEDIDO_CDPED||'(Alterao)', '');

                           UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           SET CDIMPORTAF = 'P',
                               DTIMPORTAF = SYSDATE
                           WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                                 PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                                 CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                                 SOLITE_DTENT = V_AF_SOLITE_DTENT;
                           IF SQL%ROWCOUNT = 0 THEN
                              INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                                 (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                                  CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                              VALUES
                                 (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                                  V_AF_SOLITE_DTENT, 'P', '', SYSDATE, '', '');
                           END IF;
                        ELSE
                           INSERT INTO MOVOPAF
                              (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                               CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                           VALUES
                              (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_NRAUTOFORN,
                               V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                               'PRODUTO NO IMPORTADO', 'ITEM AF J CADASTRADA');

                           UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           SET OBSIMPORTAF = 'ITEM AF J CADASTRADA',
                               CDIMPORTAF = 'N',
                               DTIMPORTAF = SYSDATE
                           WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                                 PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                                 CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                                 SOLITE_DTENT = V_AF_SOLITE_DTENT;
                           IF SQL%ROWCOUNT = 0 THEN
                              INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                                 (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                                  CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                              VALUES
                                 (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                                  V_AF_SOLITE_DTENT, 'N', 'ITEM AF J CADASTRADA', SYSDATE, '', '');
                           END IF;
                        END IF;
                        COMMIT;
                     END IF;
                  ELSE
                     INSERT INTO MOVOPAF
                        (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                         CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                     VALUES
                        (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_AF_PEDIDO_CDPED,
                         V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                         'PRODUTO NO IMPORTADO', 'PRODUTO '||V_AF_CPOPRO_CDPRO||' NO CADASTRADO');

                     UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                     SET OBSIMPORTAF = 'PRODUTO NO CADASTRADO',
                         CDIMPORTAF = 'N',
                         DTIMPORTAF = SYSDATE
                     WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                           PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                           CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                           SOLITE_DTENT = V_AF_SOLITE_DTENT;

                     IF SQL%ROWCOUNT = 0 THEN
                        INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                            CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                        VALUES
                           (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                            V_AF_SOLITE_DTENT, 'N', 'PRODUTO NO CADASTRADO', SYSDATE, '', '');
                     END IF;
                     COMMIT;
                  END IF;
               ELSE
                  INSERT INTO MOVOPAF
                     (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                      CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                  VALUES
                     (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_AF_PEDIDO_CDPED,
                      V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                      'PRODUTO NO IMPORTADO', 'FORNECEDOR '||V_AF_CADFOR_NRCGC||' NAO CADASTRADO');

                  UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                  SET OBSIMPORTAF = 'FORNECEDOR NO CADASTRADO',
                      CDIMPORTAF = 'N',
                      DTIMPORTAF = SYSDATE
                  WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                        PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                        CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                        SOLITE_DTENT = V_AF_SOLITE_DTENT;

                  IF SQL%ROWCOUNT = 0 THEN
                     INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                        (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                         CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                     VALUES
                        (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                         V_AF_SOLITE_DTENT, 'N', 'FORNECEDOR NO CADASTRADO', SYSDATE, '', '');
                  END IF;
                  COMMIT;
               END IF;
            ELSE
               INSERT INTO MOVOPAF
                  (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                   CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
               VALUES
                  (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_AF_PEDIDO_CDPED,
                   V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                   'PRODUTO NO IMPORTADO', 'EMPRESA NO CADASTRADA');

               UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
               SET OBSIMPORTAF = 'EMPRESA NO CADASTRADA',
                   CDIMPORTAF = 'N',
                   DTIMPORTAF = SYSDATE
               WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                     PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                     CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                     SOLITE_DTENT = V_AF_SOLITE_DTENT;

               IF SQL%ROWCOUNT = 0 THEN
                  INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                     (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                      CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                  VALUES
                     (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                      V_AF_SOLITE_DTENT, 'N', 'EMPRESA NO CADASTRADA', SYSDATE, '', '');

               END IF;
               COMMIT;
            END IF;
         ELSE
            INSERT INTO MOVOPAF
               (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
            VALUES
               (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_AF_PEDIDO_CDPED,
                V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                'PRODUTO NO IMPORTADO', 'FILIAL NO CADASTRADA');

            UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
            SET OBSIMPORTAF = 'FILIAL NO CADASTRADA',
                CDIMPORTAF = 'N',
                DTIMPORTAF = SYSDATE
            WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                  PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                  CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                  SOLITE_DTENT = V_AF_SOLITE_DTENT;

            IF SQL%ROWCOUNT = 0 THEN
               INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                  (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                   CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
               VALUES
                  (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                   V_AF_SOLITE_DTENT, 'N', 'FILIAL NO CADASTRADA', SYSDATE, '', '');
            END IF;
            COMMIT;
         END IF;
      ELSE
         INSERT INTO MOVOPAF
            (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
             CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
         VALUES
            (V_AF_CADFIL_CDFIL, V_AF_CADFIL_CDFIL, V_AF_PEDIDO_CDPED,
             V_AF_CPOPRO_CDPRO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
             'PRODUTO NO IMPORTADO', 'RELAC. DE PRODUTO '||V_AF_CPOPRO_CDPRO||' NO CADASTRADO');

         UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
         SET OBSIMPORTAF = 'RELACIONAMENTO DE INTEGRAO DO PRODUTO NO CADASTRADO',
             CDIMPORTAF = 'N',
             DTIMPORTAF = SYSDATE
         WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
               PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
               CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
               SOLITE_DTENT = V_AF_SOLITE_DTENT;

         IF SQL%ROWCOUNT = 0 THEN
            INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
               (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
            VALUES
               (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                V_AF_SOLITE_DTENT, 'N', 'RELACIONAMENTO DE INTEGRAO DO PRODUTO NO CADASTRADO', SYSDATE, '', '');
         END IF;
         COMMIT;
      END IF;
   END LOOP;
   FOR C_FECHAMENTO IN
      (SELECT
          SUBSTR(CDLISTA, 1, 4)  CDFILDEST,
          SUBSTR(CDLISTA, 5, 4)  CDFILLANC,
          SUBSTR(CDLISTA, 9, 10) NRAUTOFORN
       FROM LISTA
       WHERE NRLISTA = V_LISTA
       )
   LOOP
      FECHAMENTO_AF(C_FECHAMENTO.CDFILDEST, C_FECHAMENTO.CDFILLANC, C_FECHAMENTO.NRAUTOFORN);
      FOR C_ITEMAUTF IN
         (SELECT
             CDFILDEST,
             CDFILLANC,
             NRAUTOFORN,
             CDPRODUTO,
             DTPROGENTAF,
             CDMARCA,
             IDBAIXITMAF,
             QTPROGENTAF,
             QTEFETENTRAF,
             VRPREUNIAF
          FROM ITEMAUTF
          WHERE CDFILDEST  = C_FECHAMENTO.CDFILDEST
            AND CDFILLANC  = C_FECHAMENTO.CDFILLANC
            AND NRAUTOFORN = C_FECHAMENTO.NRAUTOFORN)
      LOOP
         IF NVL(C_ITEMAUTF.IDBAIXITMAF, '0') <> '3' THEN
            IF C_ITEMAUTF.QTEFETENTRAF IS NULL THEN
               IF C_ITEMAUTF.IDBAIXITMAF IS NOT NULL THEN
                  UPDATE ITEMAUTF
                  SET
                     IDBAIXITMAF    = NULL
                  WHERE CDFILDEST   = C_ITEMAUTF.CDFILDEST
                    AND CDFILLANC   = C_ITEMAUTF.CDFILLANC
                    AND NRAUTOFORN  = C_ITEMAUTF.NRAUTOFORN
                    AND CDPRODUTO   = C_ITEMAUTF.CDPRODUTO
                    AND DTPROGENTAF = C_ITEMAUTF.DTPROGENTAF
                    AND CDMARCA     = C_ITEMAUTF.CDMARCA;
               END IF;
            ELSE
               IF C_ITEMAUTF.QTPROGENTAF > C_ITEMAUTF.QTEFETENTRAF THEN
                  IF NVL(C_ITEMAUTF.IDBAIXITMAF, '0') <> '1' THEN
                     UPDATE ITEMAUTF
                     SET
                        IDBAIXITMAF    = '1'
                     WHERE CDFILDEST   = C_ITEMAUTF.CDFILDEST
                       AND CDFILLANC   = C_ITEMAUTF.CDFILLANC
                       AND NRAUTOFORN  = C_ITEMAUTF.NRAUTOFORN
                       AND CDPRODUTO   = C_ITEMAUTF.CDPRODUTO
                       AND DTPROGENTAF = C_ITEMAUTF.DTPROGENTAF
                       AND CDMARCA     = C_ITEMAUTF.CDMARCA;
                  END IF;
               ELSE
                  IF C_ITEMAUTF.QTPROGENTAF = C_ITEMAUTF.QTEFETENTRAF THEN
                     IF NVL(C_ITEMAUTF.IDBAIXITMAF, '0') <> '2' THEN
                        UPDATE ITEMAUTF
                        SET
                           IDBAIXITMAF    = '2'
                        WHERE CDFILDEST   = C_ITEMAUTF.CDFILDEST
                          AND CDFILLANC   = C_ITEMAUTF.CDFILLANC
                          AND NRAUTOFORN  = C_ITEMAUTF.NRAUTOFORN
                          AND CDPRODUTO   = C_ITEMAUTF.CDPRODUTO
                          AND DTPROGENTAF = C_ITEMAUTF.DTPROGENTAF
                          AND CDMARCA     = C_ITEMAUTF.CDMARCA;
                     END IF;
                  ELSE
                     IF C_ITEMAUTF.QTPROGENTAF < C_ITEMAUTF.QTEFETENTRAF THEN
                        UPDATE ITEMAUTF
                        SET
                           IDBAIXITMAF    = '2',
                           QTPROGENTAF    = C_ITEMAUTF.QTEFETENTRAF
                        WHERE CDFILDEST   = C_ITEMAUTF.CDFILDEST
                          AND CDFILLANC   = C_ITEMAUTF.CDFILLANC
                          AND NRAUTOFORN  = C_ITEMAUTF.NRAUTOFORN
                          AND CDPRODUTO   = C_ITEMAUTF.CDPRODUTO
                          AND DTPROGENTAF = C_ITEMAUTF.DTPROGENTAF
                          AND CDMARCA     = C_ITEMAUTF.CDMARCA;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END LOOP;

      FOR C_BAIXAAF IN
        (SELECT CONTA_ITEMS, CONTA_2, CONTA_3, CONTA_1, CONTA_NULL
         FROM
            (SELECT COUNT(*) AS CONTA_ITEMS /* Nmero de itens de uma AF */
             FROM ITEMAUTF
             WHERE (CDFILDEST   = C_FECHAMENTO.CDFILDEST) AND
                   (CDFILLANC   = C_FECHAMENTO.CDFILLANC) AND
                   (NRAUTOFORN  = C_FECHAMENTO.NRAUTOFORN)),

            (SELECT COUNT(*) AS CONTA_2 /* Nmero de  itens com Baixa Total */
             FROM ITEMAUTF
             WHERE
               (CDFILDEST   = C_FECHAMENTO.CDFILDEST) AND
               (CDFILLANC   = C_FECHAMENTO.CDFILLANC) AND
               (NRAUTOFORN  = C_FECHAMENTO.NRAUTOFORN) AND
               (IDBAIXITMAF = '2' )),

            (SELECT COUNT(*) AS CONTA_3 /* Nmero de  itens com Baixa Manual */
             FROM ITEMAUTF
             WHERE
               (CDFILDEST   = C_FECHAMENTO.CDFILDEST) AND
               (CDFILLANC   = C_FECHAMENTO.CDFILLANC) AND
               (NRAUTOFORN  = C_FECHAMENTO.NRAUTOFORN) AND
               (IDBAIXITMAF = '3' )),

            (SELECT COUNT(*) AS CONTA_1   /* Nmero de itens com Baixa Parcial */
             FROM ITEMAUTF
             WHERE
               (CDFILDEST   = C_FECHAMENTO.CDFILDEST) AND
               (CDFILLANC   = C_FECHAMENTO.CDFILLANC) AND
               (NRAUTOFORN  = C_FECHAMENTO.NRAUTOFORN) AND
               (IDBAIXITMAF = '1')),

            (SELECT COUNT(*) AS CONTA_NULL   /* Nmero de itens Em Aberto */
             FROM ITEMAUTF
             WHERE
               (CDFILDEST   = C_FECHAMENTO.CDFILDEST) AND
               (CDFILLANC   = C_FECHAMENTO.CDFILLANC) AND
               (NRAUTOFORN  = C_FECHAMENTO.NRAUTOFORN) AND
               (IDBAIXITMAF IS NULL)))
      LOOP
         IF C_BAIXAAF.CONTA_ITEMS = 0 THEN
            V_BAIXA_AF := NULL;
         ELSE
            IF C_BAIXAAF.CONTA_1 > 0 THEN
               V_BAIXA_AF := '1';
            ELSE
               IF
                  ( ((C_BAIXAAF.CONTA_NULL > 0) AND (C_BAIXAAF.CONTA_NULL < C_BAIXAAF.CONTA_ITEMS)) OR

                    ((C_BAIXAAF.CONTA_ITEMS = C_BAIXAAF.CONTA_NULL + C_BAIXAAF.CONTA_2 + C_BAIXAAF.CONTA_3) AND
                     ((C_BAIXAAF.CONTA_NULL > 0) OR (C_BAIXAAF.CONTA_1 > 0)))
                   ) AND

                  (C_BAIXAAF.CONTA_NULL < C_BAIXAAF.CONTA_ITEMS) AND
                  (C_BAIXAAF.CONTA_2    < C_BAIXAAF.CONTA_ITEMS) AND
                  (C_BAIXAAF.CONTA_3    < C_BAIXAAF.CONTA_ITEMS) THEN
                  V_BAIXA_AF := '1';
               ELSE
                  IF C_BAIXAAF.CONTA_2 = C_BAIXAAF.CONTA_ITEMS THEN
                     V_BAIXA_AF := '2';
                  ELSE
                     IF C_BAIXAAF.CONTA_3 = C_BAIXAAF.CONTA_ITEMS THEN
                        V_BAIXA_AF := '3';
                     ELSE
                        IF (C_BAIXAAF.CONTA_NULL = 0) AND (C_BAIXAAF.CONTA_1 = 0) THEN
                           V_BAIXA_AF := '3';
                        ELSE
                           V_BAIXA_AF := NULL;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
         UPDATE
            AUTOFORNE
         SET
            IDBAIXAAF  = V_BAIXA_AF
         WHERE
            CDFILDEST  = C_FECHAMENTO.CDFILDEST AND
            CDFILLANC  = C_FECHAMENTO.CDFILLANC AND
            NRAUTOFORN = C_FECHAMENTO.NRAUTOFORN;
      END LOOP;
      COMMIT;
   END LOOP;
   DELETE FROM LISTA WHERE NRLISTA = V_LISTA;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_IMPORTA_AF','5.05.125'); END;
/

