/* Sistemas Integrados TECNISA
   Compras

Nome: INSERE_PRODFORNCMP_MARCFORNCMP

Descrio:
Insero nas tabelas PRODFORNCOMP e MARCPRODCOMP

P_CDFORNECED - Fornecedor
P_CDMARCA    - Marca
P_CDPRODUTO  - Produto

Para aplicar e debugar
 @C:\WIN_V4\SQL\END_CONV\ORACLE\8770_CMPSTPO.SQL;

Criao:
24/08/2004 - Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'INSERE_PRODFORNCMP_MARCFORNCMP'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)

   DROP PROCEDURE INSERE_PRODFORNCMP_MARCFORNCMP;
GO

CREATE PROCEDURE INSERE_PRODFORNCMP_MARCFORNCMP
                                  @P_CDFORNECED VARCHAR(21),
                                  @P_CDMARCA    VARCHAR(5),
                                  @P_CDPRODUTO  VARCHAR(10),
                                  @P_CDARVPROD  VARCHAR(20),
                                  @P_ARRED      VARCHAR(1) = NULL,
                                  @P_CDFORNORIG VARCHAR(21) = NULL
AS

DECLARE @V_CDPRODCOMPL VARCHAR(10);

BEGIN
   DECLARE CUR_CONTPROD CURSOR FOR
      SELECT
          CDPRODUTO AS CDPRODCOMPL
       FROM
          PRODUTO
       WHERE
          (@P_CDARVPROD  = CDARVPROD OR
           CDARVPROD LIKE @P_CDARVPROD + '%') AND
           CDPRODESTO IS NOT NULL;

   OPEN CUR_CONTPROD;

   FETCH NEXT FROM CUR_CONTPROD INTO @V_CDPRODCOMPL;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @P_CDFORNECED IS NOT NULL BEGIN
         IF (@P_ARRED IS NOT NULL) BEGIN
            IF (@P_ARRED = 'E') BEGIN
               IF (@P_CDFORNORIG IS NOT NULL) BEGIN
                  INSERT INTO PRODFORNCOMP
                    (CDFORNECED, CDPRODUTO, CDPRODCOMPL, VRARREDEMPE)
                 (SELECT
                     @P_CDFORNECED,
                     @P_CDPRODUTO,
                     @V_CDPRODCOMPL,
                     P.VRARREDEMPE
                  FROM
                     PRODFORNCOMP P
                  WHERE
                     P.CDPRODCOMPL = @V_CDPRODCOMPL AND
                     P.CDFORNECED  = @P_CDFORNORIG  AND
                     P.CDPRODUTO   = @P_CDPRODUTO   AND
                     NOT EXISTS(SELECT
                                   CDFORNECED,
                                   CDPRODUTO,
                                   CDPRODCOMPL
                                FROM
                                   PRODFORNCOMP
                                WHERE
                                   CDFORNECED   = @P_CDFORNECED AND
                                   CDPRODCOMPL  = @V_CDPRODCOMPL));
               END
               ELSE BEGIN
                  INSERT INTO PRODFORNCOMP
                     (CDFORNECED, CDPRODUTO, CDPRODCOMPL)
                  (SELECT
                      @P_CDFORNECED,
                      @P_CDPRODUTO,
                      @V_CDPRODCOMPL
                   FROM
                      PARAMGERAL
                   WHERE
                      NOT EXISTS(SELECT
                                    CDFORNECED,
                                    CDPRODUTO,
                                    CDPRODCOMPL
                                 FROM
                                    PRODFORNCOMP
                                 WHERE
                                    CDFORNECED   = @P_CDFORNECED AND
                                    CDPRODCOMPL  = @V_CDPRODCOMPL));
               END;
            END
            ELSE BEGIN
               INSERT INTO PRODFORNCOMP
                 (CDFORNECED, CDPRODUTO, CDPRODCOMPL, VRARREDEMPE)
              (SELECT
                  @P_CDFORNECED,
                  @P_CDPRODUTO,
                  @V_CDPRODCOMPL,
                  P.VRARREDEMPPR
               FROM
                  PRODUTO P
               WHERE
                  P.CDPRODUTO   = @V_CDPRODCOMPL AND
                  NOT EXISTS(SELECT
                                CDFORNECED,
                                CDPRODUTO,
                                CDPRODCOMPL
                             FROM
                                PRODFORNCOMP
                             WHERE
                                CDFORNECED   = @P_CDFORNECED AND
                                CDPRODCOMPL  = @V_CDPRODCOMPL));
            END;
         END
         ELSE BEGIN
            INSERT INTO PRODFORNCOMP
               (CDFORNECED, CDPRODUTO, CDPRODCOMPL)
            (SELECT
                @P_CDFORNECED,
                @P_CDPRODUTO,
                @V_CDPRODCOMPL
             FROM
                PARAMGERAL
             WHERE
                NOT EXISTS(SELECT
                              CDFORNECED,
                              CDPRODUTO,
                              CDPRODCOMPL
                           FROM
                              PRODFORNCOMP
                           WHERE
                              CDFORNECED   = @P_CDFORNECED AND
                              CDPRODCOMPL  = @V_CDPRODCOMPL));
         END;
      END;

      IF @P_CDMARCA IS NOT NULL BEGIN

         INSERT INTO MARCPRODCOMP
            (CDMARCA, CDPRODUTO, CDPRMARCOMPL)
         (SELECT
             @P_CDMARCA,
             @P_CDPRODUTO,
             @V_CDPRODCOMPL
         FROM
             PARAMGERAL
         WHERE
             NOT EXISTS(SELECT
                           CDMARCA,
                           CDPRODUTO,
                           CDPRMARCOMPL
                        FROM
                           MARCPRODCOMP
                        WHERE
                           CDMARCA      = @P_CDMARCA    AND
                           CDPRMARCOMPL = @V_CDPRODCOMPL));
      END;
      FETCH NEXT FROM CUR_CONTPROD INTO @V_CDPRODCOMPL;
   END;
   CLOSE CUR_CONTPROD;
   DEALLOCATE CUR_CONTPROD;  
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'INSERE_PRODFORNCMP_MARCFORNCMP','5.01.014';
GO

